package cn.com.qmth.examcloud.core.basic.dao;

import java.util.List;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.QueryByExampleExecutor;

import cn.com.qmth.examcloud.core.basic.dao.entity.OrgEntity;

/**
 * Created by songyue on 17/1/13.
 */
public interface OrgRepo
		extends
			JpaRepository<OrgEntity, Long>,
			QueryByExampleExecutor<OrgEntity>,
			JpaSpecificationExecutor<OrgEntity> {

	List<OrgEntity> findByRootId(Long rootId);

	List<OrgEntity> findByParentIdAndNameLikeAndEnable(Long parentId, String name, Boolean enable);

	OrgEntity findByParentIdAndCode(Long parentId, String code);

	OrgEntity findByRootIdAndCode(Long rootId, String code);

	List<OrgEntity> findByRootIdAndNameLike(Long rootId, String name);

	List<OrgEntity> findByParentIdAndEnable(Long parentId, Boolean enable);

	@Query(value = "select t from OrgEntity t where t.parentId is null and t.code=?1")
	OrgEntity findRootOrgByCode(String code);

	@Query(value = "select t from OrgEntity t where t.parentId is null and t.id =?1")
	OrgEntity findRootOrgById(Long rootOrgId);

}
